#!/usr/bin/env python
# -*- encoding: utf-8 -*-
'''
@Date:2022/07/19 10:49:15
'''
import sys
sys.path.append('.')

import datetime
from sqlalchemy import or_, and_, asc, desc
from sqlalchemy.sql import func
from db_logic.db_base import Repository

from models.medicament_models import EntityMedicamentRecord
# from common.utils import Utils

#药剂流转记录业务逻辑类
class BllMedicamentRecord(Repository):
    #_instance_lock = threading.Lock()
    ##实现单例模式
    #def __new__(cls, *args, **kwargs):
    #    if not hasattr(BllMedicamentRecord, "_instance"):
    #        with BllMedicamentRecord._instance_lock:
    #            if not hasattr(BllMedicamentRecord, "_instance"):
    #                BllMedicamentRecord._instance = object.__new__(cls)
    #    return BllMedicamentRecord._instance

    def __init__(self, entityType=EntityMedicamentRecord):
        return super().__init__(entityType)

    def get_today_record_number(self,):
        self.entityType.query()


        return
    # #获取指定用户流转记录
    # def getUserDrugRecordList(self, pageParam, customerId, userId=None):
    #     queryStr = 'select * from RMS_MedicamentRecord r left join RMS_Medicament m on m.MedicamentId=r.MedicamentId and m.CustomerId=:customerId '
    #     queryParams = {"customerId": customerId}
    #     if(userId):
    #         queryStr += ' where CreateUserId=:userId order by CreateDate desc'
    #         queryParams["userId"] = userId
    #     else:
    #         queryStr += ' order by CreateDate desc'
    #     templateList = self.execute(queryStr + ' limit ' + str((pageParam.curPage - 1)
    #                                 * pageParam.pageRows) + ',' + str(pageParam.pageRows), queryParams).fetchall()
    #     pageParam.totalRecords = self.execute(
    #         queryStr.replace('*', 'count(*)'), queryParams).fetchone()[0]
    #     jsonData = Utils.mysqlTable2Model(templateList)
    #     return jsonData

    #获取今日药剂流转信息数量
    def getTodayDrugRecordCount(self, customerId, clientId):
        todayDate = datetime.datetime.now().strftime("%Y-%m-%d")
        # 使用类型进行分组，直接获取入库，领用，归还的数量
        recordListNew = self.session.query(
            self.entityType.record_type,
            func.count('record_id')
            ).select_from(self.entityType).filter(
                EntityMedicamentRecord.customer_id == customerId,
                EntityMedicamentRecord.client_id == clientId,
                func.date_format(EntityMedicamentRecord.create_date, '%Y-%m-%d') == todayDate
            ).group_by(EntityMedicamentRecord.record_type).all()
        return dict(recordListNew)
    

    # 获取报表统计内入库记录信息
    def get_drug_record_count(self):
        query_li = [
            self.entityType.record_type,
            func.count('record_id'),
            func.max(self.entityType.create_date)
            ]
        data = self.session.query(
            *tuple(query_li)
        ).select_from(self.entityType).group_by(EntityMedicamentRecord.record_type).all()
        return data
        

    # #获取药剂最后一次使用余量
    # def getLastRecordRemain(self, drugId):
    #     SQL = """
    #     select RecordRemain from rms_medicamentrecord WHERE MedicamentId='""" + drugId + """' ORDER BY CreateDate DESC LIMIT 1 
    #     """
    #     try:
    #         result = BllMedicamentRecord().execute(SQL)
    #         return float(result.fetchone()[0])
    #     except Exception as e:
    #         print(e)
    #         return 0

    # #删除药剂最后一次领用记录
    # def deleteLastUseRecord(self, drugId):
    #     SQL = """
    #     delete from rms_medicamentrecord WHERE MedicamentId='""" + drugId + """' and RecordType=2  ORDER BY CreateDate DESC LIMIT 1 
    #     """
    #     result = BllMedicamentRecord().executeNoParam(SQL)
    #     return result


if __name__ == '__main__':
    from db_logic.medicament_record import BllMedicamentRecord
    customerId, clientId = None, '8db7e540-070f-11ed-a286-f47b094925e1'
    typ_dic = BllMedicamentRecord().get_drug_record_count()
    # typ_dic[4] = typ_dic[2] - typ_dic[3]
    print(typ_dic)
